Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.poi.xssf.model
Class SharedStringsTable

    java.lang.Object
      org.apache.poi.POIXMLDocumentPart
          org.apache.poi.xssf.model.SharedStringsTable

    public class SharedStringsTable

extends POIXMLDocumentPart

Table of strings shared across all sheets in a workbook.

A workbook may contain thousands of cells containing string (non-numeric) data. Furthermore this data is very likely to be repeated across many rows or columns. The goal of implementing a single string table that is shared across the workbook is to improve performance in opening and saving the file by only reading and writing the repetitive information once.

Consider for example a workbook summarizing information for cities within various countries. There may be a column for the name of the country, a column for the name of each city in that country, and a column containing the data for each city. In this case the country name is repetitive, being duplicated in many cells. In many cases the repetition is extensive, and a tremendous savings is realized by making use of a shared string table when saving the workbook. When displaying text in the spreadsheet, the cell table will just contain an index into the string table as the value of a cell, instead of the full string.

The shared string table contains all the necessary information for displaying the string: the text, formatting properties, and phonetic properties (for East Asian languages).

Author:
  Nick Birch, Yegor Kozlov

Field Summary

Fields inherited from class org.apache.poi.POIXMLDocumentPart
`DEFAULT_XML_OPTIONS`

Constructor Summary
`SharedStringsTable()`
`SharedStringsTable(PackagePart part, PackageRelationship rel)`

Method Summary
`int` | `addEntry(org.openxmlformats.schemas.spreadsheetml.x2006.main.CTRst st)` Add an entry to this Shared String table (a new value is appened to the end).
`int` | `getCount()` Return an integer representing the total count of strings in the workbook.
`org.openxmlformats.schemas.spreadsheetml.x2006.main.CTRst` | `getEntryAt(int idx)` Return a string item by index
`java.util.List` | `getItems()` Provide low-level access to the underlying array of CTRst beans
`int` | `getUniqueCount()` Returns an integer representing the total count of unique strings in the Shared String Table.
`void` | `readFrom(java.io.InputStream is)` Read this shared strings table from an XML file.
`void` | `writeTo(java.io.OutputStream out)` Write this table out as XML.

Methods inherited from class org.apache.poi.POIXMLDocumentPart
`createRelationship, createRelationship, getPackagePart, getPackageRelationship, getParent, getRelations, removeRelation, toString`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SharedStringsTable

    public SharedStringsTable()

### SharedStringsTable

    public SharedStringsTable(PackagePart part,
                              PackageRelationship rel)
                       throws java.io.IOException

Throws:
  `java.io.IOException`

Method Detail

### readFrom

    public void readFrom(java.io.InputStream is)
                  throws java.io.IOException

  Read this shared strings table from an XML file.

  Parameters:
    `is` - The input stream containing the XML document.
  Throws:
    `java.io.IOException` - if an error occurs while reading.

### getEntryAt

    public org.openxmlformats.schemas.spreadsheetml.x2006.main.CTRst getEntryAt(int idx)

  Return a string item by index

  Parameters:
    `idx` - index of item to return.
  Returns:
    the item at the specified position in this Shared String table.

### getCount

    public int getCount()

  Return an integer representing the total count of strings in the workbook. This count does not include any numbers, it counts only the total of text strings in the workbook.

  Returns:
    the total count of strings in the workbook

### getUniqueCount

    public int getUniqueCount()

  Returns an integer representing the total count of unique strings in the Shared String Table. A string is unique even if it is a copy of another string, but has different formatting applied at the character level.

  Returns:
    the total count of unique strings in the workbook

### addEntry

    public int addEntry(org.openxmlformats.schemas.spreadsheetml.x2006.main.CTRst st)

  Add an entry to this Shared String table (a new value is appened to the end).

  If the Shared String table already contains this `CTRst` bean, its index is returned. Otherwise a new entry is aded.

  Parameters:
    `st` - the entry to add
  Returns:
    index the index of added entry

### getItems

    public java.util.List getItems()

  Provide low-level access to the underlying array of CTRst beans

  Returns:
    array of CTRst beans

### writeTo

    public void writeTo(java.io.OutputStream out)
                 throws java.io.IOException

  Write this table out as XML.

  Parameters:
    `out` - The stream to write to.
  Throws:
    `java.io.IOException` - if an error occurs while writing.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD